#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define int long long
#define F first
#define S second
#define ios ios_base::sync_with_stdio(false); cin.tie(0);
#define endl '\n'
using namespace __gnu_pbds;
using namespace std;
int n, k, t;
vector<vector<int>> edge;
inline bool check(int x, int i){
    int f = (i + x - 1) / x - 1, s = (n - 1 - i + x - 1) / x - 1;
    if(max(f, 0LL) + max(s, 0LL) > k)
        return false;
    return true;
}
inline void solve2(){
    for(int i = 0; i < n ;i ++){
        int l = 1, r = n;
        while(r > l + 1){
            int m = (r + l) / 2;
            if(check(m, i))
                r = m;
            else
                l = m;
        }
        if(check(l, i))
            r = l;
        cout<<r<<" ";
        if(t == 0)
            break;
    }
    cout<<endl;
}
vector<int> p, rd;
vector<pair<int, int>> d;
void dfs(int v){
    for(auto i : edge[v]){
        if(i == p[v])
            continue;
        p[i] = v;
        rd[i] = rd[v] + 1;
        d[i] = {rd[i], i};
        dfs(i);
    }
}
vector<bool> used;
void upd(int v){
    used[v] = true;
    for(auto i :edge[v]){
        if(i == p[v] || used[i])
            continue;
        upd(i);
    }
}
inline bool check(int x){
    fill(used.begin(), used.end(), false);
    int cnt = 0;
    for(int i = n - 1; i >= 0; i--){
        if(used[d[i].S])
            continue;
        if(d[i].F <= x)
            break;
        cnt ++;
        int u = d[i].S, pr = u;
        while(d[i].F - rd[u] + 1 <= x){
            pr = u;
            u = p[u];
        }
        if(d[i].F - rd[pr] + 1 > x)
            return false;
        upd(pr);
    }
    return cnt <= k;
}
inline void solve(){
    rd.resize(n);
    p.resize(n);
    d.resize(n);
    used.resize(n);
    for(int i = 0; i < n ;i ++){
        p[i] = i;
        rd[i] = 0;
        d[i] = {rd[i], i};
        dfs(i);
        sort(d.begin(), d.end());
        int l = 0, r = n;
        while(r > l + 1){
            int m = (r + l) / 2;
            if(check(m))
                r = m;
            else
                l = m;
        }
        if(check(l))
            r = l;
        cout<<r<<" ";
        if(t == 0)
            break;
    }
    cout<<endl;
}
signed main() {
    ios
    cin>>n>>k>>t;
    edge.resize(n);
    bool was = true;
    for(int i = 0; i < n - 1; i ++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        edge[u].push_back(v);
        edge[v].push_back(u);
        if(u != i || v != i + 1)
            was = false;
    }
    if(was)
        solve2();
    else
        solve();

}
