#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define F first
#define S second
#define ios ios_base::sync_with_stdio(false); cin.tie(0);
#define endl '\n'
using namespace std;
using namespace __gnu_pbds;

const int R = 1<<17;
vector<pair<int, int>> ch;
vector<int> xs, ind, h, l, t, fl;
vector<pair<int, int>> sz, otr;
int timer = 0, cl = 0;
bool is = true;
set<int> hs;
void dfs(int v = 0, int pr = 0){
    if(v == -1)
        return;
    h[v] = h[pr] + 1;
    l[v] = cl;
    if(xs[v] == -1)
        ind[v] = timer++;
    dfs(ch[v].F, v);
    if(xs[v] == 0)
        ind[v] = timer++;
    dfs(ch[v].S, v);
    if(xs[v] == 1)
        ind[v] = timer++;
    if(is && ch[v].F == -1)
        hs.insert(h[v]);
    cl++;
}
vector<vector<pair<int, int>>> ways;
vector<pair<int, int>> way;
void calc(int v = 0){
    ways[v] = way;
    way.push_back({v, 0});
    if(ch[v].F != -1) {
        calc(ch[v].F);
        sz[v].F = sz[ch[v].F].F + sz[ch[v].F].S + 1;
    }
    way.back().S = 1;
    if(ch[v].S != -1) {
        calc(ch[v].S);
        sz[v].S = sz[ch[v].S].F + sz[ch[v].S].S + 1;
    }
    way.pop_back();
}
vector<int> eul;
void mcalc(int v){
    if(ch[v].F != -1) {
        mcalc(ch[v].F);
        sz[v].F = sz[ch[v].F].F + sz[ch[v].F].S + 1;
    }
    if(ch[v].S != -1) {
        mcalc(ch[v].S);
        sz[v].S = sz[ch[v].S].F + sz[ch[v].S].S + 1;
    }
    otr[v] = {l[v], (int)eul.size()};
    t[otr[v].S + R] = ind[v] + 1;
    eul.push_back(v);
}
inline void push2(int v){
    for(int i = 2 * v; i <= 2 * v + 1 ; i ++){
        fl[i] += fl[v];
        t[i] += fl[v];
    }
    fl[v] = 0;
}
void upd(int ql, int qr, int add, int l = 0, int r = R - 1, int v = 1){
    if(l > qr || ql > r)
        return;
    if(ql <= l && r <= qr){
        fl[v] += add;
        t[v] += add;
        return;
    }
    push2(v);
    int m = (l + r) / 2;
    upd(ql, qr, add, l, m, 2 * v);
    upd(ql, qr, add, m + 1, r, 2 * v + 1);
}
int getval(int pos, int l = 0, int r = R - 1, int v = 1){
    if(pos > r || pos < l)
        return -1;
    if(l == r)
        return t[v];
    push2(v);
    int m = (l + r) / 2;
    int f = getval(pos, l, m, 2 * v);
    if(f == -1)
        return getval(pos, m + 1, r, 2 * v + 1);
    return f;
}
vector<int> tr;
inline void push(int v){
    if(fl[v] == -2)
        return;
    for(int i = 2 * v; i <= 2 * v + 1; i ++)
        tr[i] = fl[i] = fl[v];
    fl[v] = -2;
}
void update(int ql, int qr, int x, int l = 0, int r = R - 1, int v = 1){
    if(ql > r || l > qr)
        return;
    if(ql <= l && r <= qr){
        fl[v] = tr[v] = x;
        return;
    }
    push(v);
    int m = (l + r) / 2;
    update(ql, qr, x, l, m, 2 * v);
    update(ql, qr, x, m + 1, r, 2 * v + 1);
}
int get(int pos, int l = 0, int r = R - 1, int v = 1){
    if(l > pos || r < pos)
        return -2;
    if(l == r)
        return tr[v];
    push(v);
    int m = (l + r) / 2;
    int f = get(pos, l, m, 2 * v);
    if(f != -2)
        return f;
    return get(pos, m + 1, r, 2 * v + 1);
}
inline void solve(){
    int n, q;
    cin>>n>>q;
    ch.resize(n);
    l.resize(n);
    for(int i = 0; i < n ;i ++) {
        cin >> ch[i].F >> ch[i].S;
        ch[i].F--,ch[i].S--;
        if((ch[i].F == -1 && ch[i].S != -1) || (ch[i].S == -1 && ch[i].F != -1))
            is = false;
    }
    xs.resize(n, - 1);
    ind.resize(n);
    h.resize(n);
    vector<pair<pair<int, int>, pair<int, int>>> req(q);
    bool poss = true, was = false;
    for(int i = 0; i < q ;i ++){
        cin>>req[i].F.F;
        if(req[i].F.F == 1) {
            cin >> req[i].F.S >> req[i].S.F >> req[i].S.S;
            poss &= !was;
        }else {
            cin >> req[i].F.S;
            was = true;
        }
    }
    if(poss){
        vector<vector<int>> add(n), del(n);
        for(int i = 0; i < q; i ++){
            if(req[i].F.F == 1){
                add[req[i].F.S - 1].push_back(i);
                del[req[i].S.F - 1].push_back(i);
            }
        }
        set<int> c;
        for(int i = 0; i < n ;i ++){
            for(auto j : add[i])
                c.insert(j);
            if(!c.empty())
                xs[i] = req[*c.rbegin()].S.S;
            for(auto j : del[i])
                c.erase(j);
        }
        timer = 0;
        dfs();
        for(int i = 0; i < q; i ++){
            if(req[i].F.F == 2)
                cout<<ind[req[i].F.S - 1] + 1<<endl;
        }
        return;
    }

    timer = 0;
    h[0] = -1;
    sz.resize(n);
    dfs();
    is &= (hs.size() == 1);
    if(is){
        is = false;
        ways.resize(n);
        l.resize(n);
        calc();
        fl.resize(2 * R, -2);
        tr.resize(2 * R, -1);
        for(int i = 0; i < q ;i ++){
            if(req[i].F.F == 1){
                update(req[i].F.S - 1, req[i].S.F - 1, req[i].S.S);
            }else{
                int j = req[i].F.S - 1;
                int pos = l[j], val = get(j);
                if(val == 0)
                    pos += sz[j].F;
                if(val == 1)
                    pos += sz[j].F + sz[j].S;
                for(auto k : ways[j]){
                    val = get(k.F);
                    if(val == -1 || (val == 0 && k.S == 1))
                        pos++;
                }
                cout<<pos + 1<<endl;
            }
        }
        return;
    }
    t.resize(2 * R);
    fl.resize(2 * R);
    otr.resize(n);
    mcalc(0);
    for(int i = 0; i < q; i ++){
        if(req[i].F.F == 1){
            for(int j = req[i].F.S - 1; j <= req[i].S.F - 1; j ++) {
                if(xs[j] == req[i].S.S)
                    continue;
                if(xs[j] == -1)
                    upd(otr[j].F, otr[j].S, -1);
                if(xs[j] == 0) {
                    upd(otr[j].F + sz[j].F, otr[j].S, -1);
                    upd(otr[j].S, otr[j].S, -sz[j].F);
                }
                if(xs[j] == 1)
                    upd(otr[j].S, otr[j].S, -sz[j].F - sz[j].S - 1);
                xs[j] = req[i].S.S;
                if(xs[j] == -1)
                    upd(otr[j].F, otr[j].S, 1);
                if(xs[j] == 0) {
                    upd(otr[j].F + sz[j].F, otr[j].S, 1);
                    upd(otr[j].S, otr[j].S, sz[j].F);
                }
                if(xs[j] == 1)
                    upd(otr[j].S, otr[j].S, sz[j].F + sz[j].S + 1);
            }
        }else{
            int j = req[i].F.S - 1;
            cout<<getval(otr[j].S)<<endl;
        }
    }
}
signed main() {
    ios
    int T = 1;
    while(T--)
        solve();
}