#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define F first
#define S second
#define ios ios_base::sync_with_stdio(false); cin.tie(0);
#define endl '\n'
using namespace __gnu_pbds;
using namespace std;
int n, k, m;
vector<vector<int>> edge;

inline bool check(int x, int i) {
    int f = (i + x - 1) / x - 1, s = (n - 1 - i + x - 1) / x - 1;
    if (max(f, 0) + max(s, 0) > k)
        return false;
    return true;
}

inline void solve2(int t) {
    for (int i = 0; i < n; i++) {
        int l = 1, r = n;
        while (r > l + 1) {
            int m = (r + l) / 2;
            if (check(m, i))
                r = m;
            else
                l = m;
        }
        if (check(l, i))
            r = l;
        cout << r << " ";
        if (t == 0)
            break;
    }
    cout << endl;
}

int R = 1;
vector<pair<int, int>> t;
vector<pair<pair<int, int>, pair<int, int>>> tr, fltr;
vector<int> fl;
inline void push(int v) {
    if (!fl[v])
        return;
    for (int i = 2 * v; i <= 2 * v + 1; i++) {
        t[i].F += fl[v];
        fl[i] += fl[v];
    }
    fl[v] = 0;
}
inline void pushtr(int v){
    if(fltr[v].F.F == -2)
        return;
    for(int i = 2 * v; i <= 2 * v + 1; i ++)
        tr[i] = fltr[i] = fltr[v];
    fltr[v] = {{-2, -2}, {-2, -2}};
}
void upd(int ql, int qr, pair<pair<int, int>, pair<int, int>> val, int l = 0, int r = R - 1, int v = 1){
    if(l > qr || ql > r)
        return;
    if(ql <= l && r <= qr){
        tr[v] = fltr[v] = val;
        return;
    }
    pushtr(v);
    int med = (l + r) / 2;
    upd(ql, qr, val, l, med, 2 * v);
    upd(ql, qr, val, med + 1, r, 2 * v + 1);
    tr[v] = max(tr[2 * v], tr[2 * v + 1]);
}
pair<pair<int, int>, pair<int, int>> find(int ql, int qr, int l = 0, int r = R - 1, int v = 1){
    if(ql > r || l > qr)
        return {{-1, -1}, {-1, -1}};
    if(ql <= l && r <= qr){
        if(tr[v].F.F == -1)
            return tr[v];
        while(v < R){
            pushtr(v);
            if(tr[2 * v].F.F != -1)
                v *= 2;
            else
                v = 2 * v + 1;
        }
        return tr[v];
    }
    pushtr(v);
    int med = (l + r) / 2;
    pair<pair<int, int>, pair<int, int>> f = find(ql, qr, l, med, 2 * v);
    if(f.F.F != -1)
        return f;
    return find(ql, qr, med + 1, r, 2 * v + 1);
}

inline void build() {
    for (int i = R - 1; i >= 0; i--)
        t[i] = max(t[2 * i], t[2 * i + 1]);
}

void update(int ql, int qr, int x, int l = 0, int r = R - 1, int v = 1) {
    if (ql > r || l > qr)
        return;
    if (ql <= l && r <= qr) {
        t[v].F += x;
        fl[v] += x;
        return;
    }
    push(v);
    int med = (l + r) / 2;
    update(ql, qr, x, l, med, 2 * v);
    update(ql, qr, x, med + 1, r, 2 * v + 1);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

pair<int, int> get(int ql, int qr, int l = 0, int r = R - 1, int v = 1) {
    if (ql > r || l > qr)
        return {0, 0};
    if (ql <= l && r <= qr)
        return t[v];
    push(v);
    int med = (l + r) / 2;
    return max(get(ql, qr, l, med, 2 * v), get(ql, qr, med + 1, r, 2 * v + 1));
}
inline void ban(int l, int r){
     while(true){
        pair<pair<int, int>, pair<int, int>> f = find(l, r);
        if(f.F.F == -1)
            break;
        pair<int, int> otr = f.S;
        if(otr.F < l) {
            upd(otr.F, l - 1, {get(otr.F, l - 1), {otr.F, l - 1}});
            otr.F = l;
        }
        if(otr.S > r){
            upd(r + 1, otr.S, {get(r + 1, otr.S), {r + 1, otr.S}});
            otr.S = r;
        }
        upd(otr.F, otr.S, {{-1, -1}, {-1, -1}});
    }
}
const int C = 18;
vector<vector<int>> up, comp;
vector<vector<pair<int, int>>> st;
vector<int> p, ind, eul, pos, lg, rpos;
vector<pair<int, int>> d;
void dfs2(int v){
    rpos[v] = pos[v] = (int)eul.size();
    eul.push_back(v);
    up[0][v] = p[v];
    for(int i = 1; i < C; i ++)
        up[i][v] = up[i - 1][up[i - 1][v]];
    for(auto i : edge[v]){
        if(i == p[v])
            continue;
        p[i] = v;
        d[i] = {d[v].F + 1, i};
        dfs2(i);
        rpos[v] = (int)eul.size();
        eul.push_back(v);
        if(d[d[i].S].F > d[d[v].S].F)
            d[v].S = d[i].S;
    }
    ind[v] = (int)comp[d[v].S].size();
    comp[d[v].S].push_back(v);
}
inline int La(int v, int x){
    if(x == 0)
        return v;
    int b = lg[x];
    v = up[b][v];
    return comp[d[v].S][ind[v] + x - (1<<b)];
}
inline int lca(int l, int r){
    l = pos[l], r = pos[r];
    if(l > r)
        swap(l, r);
    int x = lg[r - l + 1];
    return min(st[x][l], st[x][r - (1<<x) + 1]).S;
}
inline bool isan(int u, int v){
    return pos[u] <= pos[v] && rpos[v] <= rpos[u];
}
inline int getnode(int a, int b, int num){ //v, root, index
    int v = lca(a, b);
    if(d[a].F - d[v].F >= num)
        return La(a, num);
    num = num - (d[a].F - d[v].F);
    return La(b, d[b].F - d[v].F - num);
}

int root;
inline bool check(int x) {
    upd(0, m - 1, {t[1], {0, m - 1}});
    for(int i = 0; i < k ;i ++){
        pair<pair<int, int>, pair<int, int>> v = tr[1];
        if(v.F.F <= x)
            return true;
        int u = getnode(v.F.S, root, x - 1);
        if(isan(root, u) || !isan(u, root))
            ban(pos[u], rpos[u]);
        else{
            u = getnode(u, root, 1);
            if (pos[u] != 0)
                ban(0, pos[u] - 1);
            if (rpos[u] != m - 1)
                ban(rpos[u] + 1, m - 1);
        }
    }
    pair<pair<int, int>, pair<int, int>> v = tr[1];
    return v.F.F <= x;
}
vector<int> ans;
inline void calc() {
    int l = 1, r = n;
    while (r > l + 1) {
        int med = (r + l) / 2;
        if (check(med))
            r = med;
        else
            l = med;
    }
    if (check(l))
        r = l;
    ans[root] = r;
}

void DFS(int v){
    if(v != 0) {
        root = v;
        calc();
    }
    for(auto i : edge[v]){
        if(i == p[v])
            continue;
        update(0, m - 1, 1);
        update(pos[i], rpos[i], -2);
        DFS(i);
        update(0, m - 1, -1);
        update(pos[i], rpos[i], 2);
    }
}
inline void solve(int T) {
    up.resize(C, vector<int> (n));
    ans.resize(n);
    p.resize(n);
    rpos.resize(n);
    lg.resize(5 * n + 1);
    lg[0] = 0;
    for(int i = 1; i <= 5 * n ;i ++){
        lg[i] = lg[i - 1];
        for(int j = 0; j < C + 10;j ++){
            if(i == (1<<j))
                lg[i] = j;
        }
    }
    pos.resize(n);
    comp.resize(n);
    d.resize(n);
    ind.resize(n);
    dfs2(0);
    for(int i = 0; i < n ;i ++){
        int len = (int)comp[i].size();
        while(len--)
            comp[i].push_back(p[comp[i].back()]);
    }
    m = (int)eul.size();
    while (R < m)
        R *= 2;
    t.resize(2 * R, {-1, -1});
    fl.resize(2 * R);
    tr.resize(2 * R, {{-1, -1}, {-1, -1}});
    fltr.resize(2 * R, {{-2, -2}, {-2, -2}});
    int K = lg[m] + 1;
    st.resize(K, vector<pair<int, int>> (m));
    for(int i = 0; i < m ; i ++)
        t[i + R] = st[0][i] = {d[eul[i]].F, eul[i]};
    for(int i = 1; i < K ;i ++){
        for(int j = 0; j <= m - (1<<i); j ++)
            st[i][j] = min(st[i - 1][j], st[i - 1][j + (1<<(i - 1))]);
    }
    build();
    root = 0;
    calc();
    if(!T) {
        cout<<ans[0]<<endl;
        return;
    }
    DFS(0);
    for(auto i : ans)
        cout<<i<<" ";
    cout<<endl;
}
vector<int> rd;
void dfs(int v){
    for(auto i : edge[v]){
        if(i == p[v])
            continue;
        p[i] = v;
        rd[i] = rd[v] + 1;
        d[i] = {rd[i], i};
        dfs(i);
    }
}
vector<bool> used;
void upd(int v){
    used[v] = true;
    for(auto i :edge[v]){
        if(i == p[v] || used[i])
            continue;
        upd(i);
    }
}
inline bool check1(int x){
    fill(used.begin(), used.end(), false);
    int cnt = 0;
    for(int i = n - 1; i >= 0; i--){
        if(used[d[i].S])
            continue;
        if(d[i].F <= x)
            break;
        cnt ++;
        int u = d[i].S, pr = u;
        while(d[i].F - rd[u] + 1 <= x){
            pr = u;
            u = p[u];
        }
        if(d[i].F - rd[pr] + 1 > x)
            return false;
        upd(pr);
    }
    return cnt <= k;
}
inline void solve3(int t){
    rd.resize(n);
    p.resize(n);
    d.resize(n);
    used.resize(n);
    for(int i = 0; i < n ;i ++){
        p[i] = i;
        rd[i] = 0;
        d[i] = {rd[i], i};
        dfs(i);
        sort(d.begin(), d.end());
        int l = 0, r = n;
        while(r > l + 1){
            int m = (r + l) / 2;
            if(check1(m))
                r = m;
            else
                l = m;
        }
        if(check1(l))
            r = l;
        cout<<r<<" ";
        if(t == 0)
            break;
    }
    cout<<endl;
}
signed main() {
    ios
    int t;
    cin >> n >> k >> t;
    edge.resize(n);
    bool was = true;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        edge[u].push_back(v);
        edge[v].push_back(u);
        if (u != i || v != i + 1)
            was = false;
    }
    if (was)
        solve2(t);
    else{
        if(n <= 2000)
            solve3(t);
        else
            solve(t);
    }
}
